#include <bits/stdc++.h>
using namespace std;

int find(string s, int j, int p, int k){
	for(int i = p;i < k;i++){
    		if(s[i] == s[j]){ return i; }
            	}
                	return -1;
                    }
                    void swap(string s, int i, int j){
                    	 char c = s[i]; s[i] = s[j]; s[j] = c;
                         }
                         void palindrom(string s, int p, int k){
                         	if(p != k){
                             		int i = find(s, p, p+1, k);
                                     		if(i == -1){
                                             			i = find(s, k, p+1, k);
                                                         			swap(s, p, i);	
                                                                     		}
                                                                             		else{ swap(s, i, k); }
                                                                                     		
                                                                                             		palindrom(s, p+1, k-1);
                                                                                                     	}
                                                                                                         }
                                                                                                         int main(){
                                                                                                         	ios::sync_with_stdio(0);
                                                                                                                     cin.tie(0);

                                                                                                                     	string s;
                                                                                                                         	cin >> s;

                                                                                                                             	int n = s.length();
                                                                                                                                 	int size = 1;
                                                                                                                                     	for(int i = 0;i < n;i++){
                                                                                                                                         		if(s[i] != s[n - 1 - i]){
                                                                                                                                                 			palindrom(s, i, n - 1 - i);	
                                                                                                                                                             			size = n - i * 2 - 1;
                                                                                                                                                                         			break;	
                                                                                                                                                                                     		}
                                                                                                                                                                                             	}

                                                                                                                                                                                                 	printf("%d \n", size);
                                                                                                                                                                                                     	return 0;
                                                                                                                                                                                                         }